// ==================================================================
//
//   path.hpp  -  Diese Datei enthlt die Definition
//                der CrashdayDirectory-Klasse, die
//                fr richtige Pfadangaben wichtig ist
//
//   Autor:    Robert Clemens
//   Start:    16.3.99
//
// ==================================================================

#ifndef _PATH_HPP_INCLUDED_

#define _PATH_HPP_INCLUDED_

#include "debug.hpp"              // Zur Fehlerbehandlung
#include "log.hpp"                // Fr LogFile
#include <fstream>                // Fr Fileobjekt
#include <string.hpp>      


#define  MAX_DIRECTORY_CHARS     256

// CrashdayDirectory-Klasse
// Die Installation legt im Crashday-Root-Verzeichnis die Datei
// "CrshPath.txt" ab, die den Crashdaypfad enthlt.
// Bentigt eine Funktion das Verzeichnis, kann es diese Funktionen aufrufen

class CrashdayDirectory
{
     public:    // ------------------------------------

         CrashdayDirectory();           // Konstruktor, ldt Pfad aus "CrshPath.txt"
         ~CrashdayDirectory();          // Destruktor

         String GetCrashdayDirectory() const;      // Zurckliefern des Crashday-Pfades
         int   GoToDirectory( String );            // CD-Pfad + String(z.B.TOOLS)
                                                   // Geht in das Verzeichnis, was im
                                                   // Crashday-Verzeichnis liegen mu

     private:  // ------------------------------------

         String   Directory;      // Zeiger auf das Verzeichnis
};


extern  CrashdayDirectory*  CDDir;   // Allgemeines Objekt fr Verzeichnisse


#endif   // path.hpp
